# LatoDemo
Lato - PC-demo originally released at Revision 2022
"Final" version released 12-Mar-2024 with two different "remixes":\
Great leaders (extended depression remix)\
Pompous maximus (extended progression remix)

Works on Godot version 4.1.3. AnimationPlayer has changed somewhat in 4.2.x breaking the animations.
4.3. is still under development at the time of writing this (11-Mar-2024,
latest 4.3. dev 4 latest version) and also breaks some animations.

This demo uses following assets (in approximate order of appearance):

Background starfield (picture):\
"The Milky way panorama"\
by ESO/S. Brunier\
https://www.hq.eso.org/public/images/eso0932a/ \
License: CC BY 4.0( https://creativecommons.org/licenses/by/4.0/ )

Satellite beeping sound:\
"Sputnik: Beep"\
by NASA\
https://soundcloud.com/nasa/sputnik-beep \
License: CC BY-NC 3.0 ( https://creativecommons.org/licenses/by-nc/3.0/ )\
Individual beeps duplicated, edited and volume (envelope) adjusted

Satellite morphing sound:\
"Luca Parmitano soyuz launch 28052013"\
by European Space Agency\
https://soundcloud.com/esa/luca-parmitano-soyuz-launch \
License: CC BY-NC-SA 3.0 ( https://creativecommons.org/licenses/by-nc-sa/3.0/ )\
Only part of the sound used and volume (envelope) adjusted

Planet probing sound/waveform:\
"Huygens Alien Descent Radar"\
by European Space Agency\
https://soundcloud.com/esa/huygens-alien-descent-radar \
License: CC BY-NC-SA 3.0 ( https://creativecommons.org/licenses/by-nc-sa/3.0/ )\
Individual pulses reorganized slightly and volume (envelope) adjusted

Descent sound/waveform:\
"Sounds of Saturn: Hear Radio Emissions of the Planet and Its Moon Enceladus"\
by NASA\
https://soundcloud.com/nasa/enceladus-hiss-audio \
License: CC BY-NC 3.0 ( https://creativecommons.org/licenses/by-nc/3.0/ )\
Only part of the sound used and volume (envelope) adjusted

Main music while "constructing" the barn:\
"Vega 28231406"\
by Ezequiel Rodríguez\
https://soundcloud.com/ezequiel-rodr-guez-1/vega-28231406 \
License: CC BY-NC-SA 3.0 ( https://creativecommons.org/licenses/by-nc-sa/3.0/ )\
Only part of the sound used and volume (envelope) adjusted

GNSS-tracked camera (3D-model):\
"Sony A6100 Camera Game Props"\
by antoineallardchoquette\
https://skfb.ly/o9sNB \
License: CC-BY-4.0 ( https://creativecommons.org/licenses/by/4.0/ )\
Some textures (button symbols/texts) slightly modified

Sound while destroying the barn/planet and ascending to space (Great leaders-remix only):\
"Beware of Jupiter’s Largest Moon Ganymede"\
by NASA\
https://soundcloud.com/nasa/beware-of-jupiters-largest-moon-ganymede \
License: CC BY-NC 3.0( https://creativecommons.org/licenses/by-nc/3.0/ )\
Volume (envelope) adjusted and part of the sound played twice

ECG(/EKG)-waveform (Great leaders-remix only):\
ECG-ID Database (Person 10, rec 3 (male, 23))\
by Tatiana Lugovaya\
https://physionet.org/content/ecgiddb/1.0.0/ \
License: ODC-By v1.0( https://physionet.org/content/ecgiddb/view-license/1.0.0/ )\
Original publication: https://www.physionet.org/physiobank/database/ecgiddb/biometric.shtml Lugovaya T.S. Biometric human identification based on electrocardiogram. [Master's thesis] Faculty of Computing Technologies and Informatics, Electrotechnical University "LETI", Saint-Petersburg, Russian Federation; June 2005.\
As the ECG was taken from material used for master's thesis for Russian university, it needs to be emphasized that the parties mentioned do not have any affiliation with this demo!

Font in "Great ??? / death"-texts (Great leaders-remix only):\
"Fette National Fraktur"\
by Peter Wiegel\
https://www.1001fonts.com/fette-national-fraktur-font.html \
License: SIL Open Font License ( https://openfontlicense.org/ )

Satellite wreck flyby / end scroller sound (Great leaders-remix only):\
"Black Hole Sonification: Perseus"\
by NASA\
https://soundcloud.com/nasa/black-hole-sonification-perseus \
License: CC BY-NC 3.0 ( https://creativecommons.org/licenses/by-nc/3.0/ )\
Volume (envelope) adjusted, parts of the sound mirrored and duplicated

Music while ascending to space station / space station flyby / end scroller (Pompous maximus-remix only):\
"Rosetta (Song for a comet)"\
by April L Gibson\
https://on.soundcloud.com/VVwoD \
License: CC BY-NC-SA 3.0 ( https://creativecommons.org/licenses/by-nc-sa/3.0/ )

Space station (Pompous maximus-remix only):\
"Space Station V (2001: A Space Odyssey)"\
by uperesito\
https://skfb.ly/6oRz8 \
License: CC BY 4.0 ( https://creativecommons.org/licenses/by/4.0/ ) \
Original created by Michael Powell for The Celestia Motherlode
("The Addon Repository for the 3D Space Simulator Celestia").
From the original ReadMe.txt: "This model was made by
Michael Powell with textures by BJ West, I had help also from
Martin Charest with the textures."

This planet generator was used to generate texture for the textured planet:\
http://hjemmesider.diku.dk/~torbenm/Planet/ \
Generated with command:\
planet -o test.bmp -s 0.41 -w 4096 -h 4096 -c

Parties mentioned above do not have any affiliation with this demo other than making their work available to use.
Big thanks for sharing!

Soundtracks are licensed under CC BY-NC-SA 3.0 (https://creativecommons.org/licenses/by-nc-sa/3.0/)
as required as derivative works of some similarly licensed sounds.

Otherwise (not counting the sounds, pictures, waveforms and models mentioned above) this demo is released under GPLv3-license.
So you need to follow the individual licenses if using any part of this demo to your purposes.

Sources and assets can be found from this project's github repo:
https://github.com/GNSS-Stylist/LatoDemo
